<?php
/**
 * ModuleAndSlices Addon
 * @author sven[t]koalshome[punkt]de Sven Eichler
 * @package redaxo3
 * @version $Id: index.inc.php 27 2007-01-27 18:58:25Z koala $
 */


// Parameter
$Basedir = dirname(__FILE__);


// Include Header and Navigation
include $REX['INCLUDE_PATH'].'/layout/top.php';


//rex_title('Module And Slices');
rex_title($I18N_MAS->msg('menu_title'), '');

// wenn Template-Klasse noch nicht eingebunden, dann hole sie jetzt rein
if (!class_exists ('Template')) {
  include_once ($REX['INCLUDE_PATH'].'/addons/moduleandslices/classes/template.inc.php');
}




// Modulwechsel einleiten
if (isset ($_POST['modulwechsel']) and isset ($_POST['module_id']) and isset ($_POST['slice_id'])) {

  // ermittle Module-ID
  $qry = 'SELECT '.$REX['TABLE_PREFIX'].'modultyp.id
          FROM '.$REX['TABLE_PREFIX'].'modultyp
          WHERE '.$REX['TABLE_PREFIX'].'modultyp.id = '.$_POST['module_id'].'';
  $MODULE_NEW = new sql;
  $MODULE_NEW->setQuery($qry);

  // ermittle Slice-ID
  $qry = 'SELECT '.$REX['TABLE_PREFIX'].'article_slice.id
          FROM '.$REX['TABLE_PREFIX'].'article_slice
          WHERE '.$REX['TABLE_PREFIX'].'article_slice.id = '.$_POST['slice_id'].'';
  $SLICE_NEW = new sql;
  $SLICE_NEW->setQuery($qry);

  // ersteinmal prfen, ob die bergebene modul_id wirklich existiert
  if ($MODULE_NEW->getRows() == 1 and $SLICE_NEW->getRows() == 1) {
    // update der betreffenden Zeile
    $qry = 'UPDATE '.$REX['TABLE_PREFIX'].'article_slice
            SET modultyp_id = "'. $_POST['module_id'] .'"
            WHERE '.$REX['TABLE_PREFIX'].'article_slice.id = "'. $_POST['slice_id'].'"
            LIMIT 1';

    $sql = new sql();
    //$sql->debugsql = true;
    $sql->setQuery($qry);
    //DebugOut('TEST: '.$qry,'sql');

    $search_arr = array ('#SLICEID#', '#MODULIDNEU#', '#MODULIDOLD#');
    $replace_arr = array ($_POST['slice_id'], $_POST['module_id'], $_POST['modul_id_old']);
    $nachricht = str_replace ($search_arr, $replace_arr, $I18N_MAS->msg("update_erfolgt"));
    echo '<table border="1" cellpadding="6" cellspacing="0" width="770" bgcolor="#eeeeee">
            <tr bgcolor="#eeeeee">
              <td class="warning">
                 <br />&nbsp;&nbsp;'.$nachricht.'<br /><br />
              </td>
            </tr>
          </table>';

  } else {

    echo '<table border="1" cellpadding="6" cellspacing="0" width="770" bgcolor="#eeeeee">
            <tr bgcolor="#eeeeee">
              <td class="warning">
                 <br><br>&nbsp;&nbsp;'.$I18N_MAS->msg("error_datenuebergabe").'<br><br><br>
              </td>
            </tr>
          </table>';
  } // if ($MODULE_NEW->getRows() == 1 and $SLICE_NEW->getRows() == 1)
} // if (isset ($_POST['modulwechsel']) and isset ($_POST['module_id']) and isset ($_POST['slice_id']))







/* create Template instance called $t */
$t = new Template(MAS_TEMPLATEPATH, "remove");
//$t->debug = 7;
//$start_dir = $_ROOT['template'].'gb_frontend_output.html';
$start_dir = 'mas_backend_output.html';

/* lese Template-Datei */
$t->set_file(array("start" => $start_dir));



// nur wenn die Suche gestartet wurde, soll etwas ausgegeben werden
if (isset ($_POST['suche'])) {

  $where_arr = array();
  if (isset ($_POST['suche_articleid']) or isset ($_POST['suche_sliceid']) or isset ($_POST['suche_modulid'])) {
    if (isset ($_POST['suche_articleid']) and $_POST['suche_articleid'] != '' and is_numeric ($_POST['suche_articleid'])) {  $where_arr['article_id'] = $_POST['suche_articleid'];  }
    if (isset ($_POST['suche_sliceid']) and $_POST['suche_sliceid'] != '' and is_numeric ($_POST['suche_sliceid'])) {  $where_arr['id'] = $_POST['suche_sliceid'];  }
    if (isset ($_POST['suche_modulid']) and $_POST['suche_modulid'] != '' and is_numeric ($_POST['suche_modulid'])) {  $where_arr['modultyp_id'] = $_POST['suche_modulid'];  }
  }

  $i = 0;
  if (count ($where_arr) >= 1) {
    $where = "\n".'WHERE ';
  } else {
    $where = '';
  }
  foreach ($where_arr as $key => $value) {
    $where .= $REX['TABLE_PREFIX'].'article_slice.'.$key.' = "'.$value.'"';
    if ($i < count ($where_arr) - 1) {
      $where .= ' AND '."\n";
    }
    $i++;
  }
  $where .= "\n";


  // ermittle alle Slices- und Artikel-IDs
  $qry = 'SELECT '.$REX['TABLE_PREFIX'].'article_slice.id, '.$REX['TABLE_PREFIX'].'article_slice.article_id,
         '.$REX['TABLE_PREFIX'].'article_slice.modultyp_id
         FROM '.$REX['TABLE_PREFIX'].'article_slice '.$where.' ORDER BY article_id, '.$REX['TABLE_PREFIX'].'article_slice.id';
  $sql = new sql();
  //    $sql->debugsql = true;
  $data = $sql->get_array($qry);
  //DebugOut('TEST: '.$qry,'sql');




  // ermittle alle Module-IDs
  $qry = 'SELECT '.$REX['TABLE_PREFIX'].'modultyp.id, '.$REX['TABLE_PREFIX'].'modultyp.name
         FROM '.$REX['TABLE_PREFIX'].'modultyp ORDER BY '.$REX['TABLE_PREFIX'].'modultyp.name';
  $MODULE = new sql;
  //    $sql->debugsql = true;
  //$MODULE = $sql_module->get_array($qry);
  $MODULE->setQuery($qry);


  if (is_array($data)) {

    $t->set_block("start", "EintragsUebersicht", "EintragsUebersicht_s");

    foreach ($data as $row) {

      $SliceID = $row['id'];
      $ModulTypID = $row['modultyp_id'];

      $MODULHIDDEN = '';
      $MODUL = '<select name="module_id">'."\n";

      for ($i=0; $i < $MODULE->getRows(); $i++) {
        $ModulName = $MODULE->getValue("name");
        $ModulID = $MODULE->getValue("id");
        if ($ModulTypID == $ModulID) {
          $MODUL .= '<option value="'.$ModulID.'" selected>['.$ModulID.'] - '.$ModulName.'</option>'."\n";
          $MODULHIDDEN = $ModulID;
        } else {
          $MODUL .= '<option value="'.$ModulID.'">['.$ModulID.'] - '.$ModulName.'</option>'."\n";
        }

        $MODULE->next();
      }
      $MODULE->resetCounter();

      $MODUL .= '</select>'."\n";


      $t->set_var(array("SLICEID"   => $SliceID,
                        "ARTICLEID" => $row['article_id'],
                        "MODULTYPID" => $ModulTypID,
                        "MODUL"      => $MODUL,
                        "SENDBUTTON" => $I18N_MAS->msg('form_button_send'),
                        "HIDDEN_SLICEID" => $SliceID,
                        "HIDDEN_MODULIDOLD" => $MODULHIDDEN
                        ));

      $t->parse("EintragsUebersicht_s", "EintragsUebersicht", true);



    } // foreach ($data as $row)

    // Module zur Ausgabe da, dann anzeigen
    $t->set_var(array("AUSGABEVORHANDEN_BEGINN" => '',
                      "AUSGABEVORHANDEN_ENDE"   => ''
                      ));

  } else {
    // Module zur Ausgabe nicht da, dann nichts anzeigen
    $t->set_var(array("AUSGABEVORHANDEN_BEGINN" => '{*',
                      "AUSGABEVORHANDEN_ENDE"   => '*}'
                      ));

  }// if (is_array($data))


} else { // if (isset ($_POST['suche']))

  // Module zur Ausgabe nicht da, dann nichts anzeigen
  $t->set_var(array("AUSGABEVORHANDEN_BEGINN" => '{*',
                    "AUSGABEVORHANDEN_ENDE"   => '*}'
                    ));




}
// komplette Seite ausgeben
$t->pparse("output", "start");







// Include Footer
include $REX['INCLUDE_PATH'].'/layout/bottom.php';
?>